% This tutorial is based on the face repetition dataset that is provided on 
% spm homepage. Go to http://www.fil.ion.ucl.ac.uk/spm/data/face_rep/ to
% dwonload the data, the manual (if needed) and some batch files that will
% allow  you to analyse the data. Together with this tutorial code, there
% is also 2 batches that only run the parts of the analysis essential for this tutorial.
% You can just run the batches provided here, or you can go thoroughly
% through all steps using the SPM manual (Chapter 31).
% to do the preprocessing run face_rep_spm12_batch_prepro.m
% !!! you need to set the variable data_path in that file. It is the path
% where the folder rawepi with the data is located.
% to get at the first glm batch run face_rep_spm12_batch_glm.m
% !!! you need to set the variable data_path in that file. It is the path
% where the folder rawepi with the data is located.
% 
% disclaimer: some of the code in this tutorial is based on the code
% provided on the SPM homepage when downloading the face repetition
% dataset.

data_path='E:\MethodsModels\FaceData';

% once you have processed the data with the two scripts, go to the folder categoTest
% start SPM using

cd(fullfile(data_path,'categoTest'));


spm fmri
load SPM % load SPM.mat for later use.

% then use the review button to check the design matrix, the covariance
% structure, and the frequency spectrum and regressors of individual
% conditions.

% us checkReg to look at the the residual image ResMS.nii and some of the beta 
% estimates.

% now let's look at some data.
% 

close all;
% load the preprocessed data 
fnames=spm_select('FPList',fullfile(data_path,'rawepi'), '^swars.*\.img$');
Y=spm_read_vols(spm_vol(fnames));

y=squeeze(Y(23,21,23,:)); %extract data from a single voxel
figure(1); clf;
plot(y); % and plot it.
y=y-mean(y); %subtract the mean and plot again.
plot(y); % and plot it.

yy=xcorr(y,20,'Coef'); % calculate the auto-correlation and plot it.
figure(2);
plot(yy); hold on;

%Lets do some filtering (take a away low frequency nois 
ylp=SPM.xX.K.X0*inv(SPM.xX.K.X0'*SPM.xX.K.X0)*SPM.xX.K.X0'*y; % project data onto low freqency space.
ydata=y-ylp; % compute residuals --> high-pass filtered data.

figure(1); clf;
subplot(2,1,1); 
plot(y);
hold;
plot(ylp);

subplot(2,1,2);
plot(ydata);

% calculate the autocorrelation of the filtered data and plot it
yy=xcorr(ydata,20,'Coef');
figure(2); hold on;
plot(yy); 

%filter the data;
ydataf=SPM.xX.W*ydata;
yyf=xcorr(ydataf,20,'Coef');
figure(2); hold on;
plot(yyf); 


% get residuals
fnames=spm_select('FPList', fullfile(data_path,'categoTest'), '^Res_.*\.nii$');
R=spm_read_vols(spm_vol(fnames));
r=squeeze(R(23,21,23,:));
figure(1); 
subplot(2,1,2); hold on; 
plot(r); % add residuals to the plot.
rr=xcorr(r,20,'Coef'); % compute autocorrelation
figure(2); hold on;
plot(rr); 

% Finally, open spm_spm.m in the editor and use it to understand what is saved
% in the different fields of the struct SPM.